import logging
import ConfigParser
from StringIO import StringIO
import datetime

from pylons import request, response, session, tmpl_context as c, url
from pylons.controllers.util import abort, redirect

from mapwocgui.lib.base import BaseController, render
from mapwocgui.model import Session
from mapwoc.lib.scanconfiguration import ScanConfiguration
import mapwocgui.model.masterproxy as master

log = logging.getLogger(__name__)

class StateController(BaseController):

    def index(self):
        c.masterproxy_state_set = master.get_state_set()
        c.master_version = master.get_version()
        c.nodestates = c.masterproxy_state_set.get('nodes')
        redirectorstate = c.masterproxy_state_set.get('redirector')
        if not redirectorstate:
            redirectorstate = {'state' : 'unreachable', 'last_urls' : [],
                               'next_urls' : ['n/a'], 'n_urls' : 0,
                               'n_urls_served' : 0, 'n_last_urls' : 0,
                               'n_next_urls' : 0,
                               'version' : 'n/a'}

        c.redirectorstate = redirectorstate.get('state')
        c.redirector_last_urls = redirectorstate.get('last_urls')
        c.redirector_next_urls = redirectorstate.get('next_urls')

        c.current_scan = c.masterproxy_state_set.get('scanname')
        if c.current_scan:
            c.current_scan_id = Session.query(ScanConfiguration).filter_by(
                    name=c.current_scan).first().id

        c.hcs = master.get_hcs()
        # Sort by name
        c.hcs = sorted(c.hcs, key=lambda hc: hc.name)

        return render('/state/index_state.mako')

