import logging

from pylons import request, response, session, tmpl_context as c, url
from pylons.controllers.util import abort, redirect

import webhelpers.paginate as paginate

from mapwocgui.lib.base import BaseController, render
from mapwocgui.model import Session

from mapwoc.lib.result import Result, Visit
from mapwoc.lib.url import URL, URLList

log = logging.getLogger(__name__)

class UrlController(BaseController):

    def index(self):
        url_query = Session.query(URL)
        c.url_paginator = paginate.Page(url_query,
                                        page=request.params.get('page', 1),
                                        items_per_page=40,)
        return render('/url/index_url.mako')

    def view(self, id):
        c.url = Session.query(URL).get(int(id))
        visits = Session.query(Visit).filter(Visit.urls.any(id=id))
        c.visit_paginator = paginate.Page(visits,
                              page=request.params.get('rpage', 1),
                              items_per_page=40,
                              )
        c.urllist_paginator = paginate.Page(
                              c.url.urllist,
                              page=request.params.get('upage', 1),
                              items_per_page=10,
                              )
        return render('/url/view_url.mako')
