<%inherit file="../base.mako"/>
<%def name="title()">${_(u"System State")}</%def>

<%def name="state_menu_style()">class="active"</%def>

<%namespace file="../base.mako" import="name_link_to_node" />
<%namespace file="../base.mako" import="box" />
<%namespace file="../base.mako" import="column50" />
<%namespace file="../base.mako" import="columnsection" />
<%namespace file="../base.mako" import="start_leftindent_hl_list"/>
<%namespace file="../base.mako" import="end_leftindent_hl_list"/>

<%self:box title="${_(u'System Overview')}">
 <div>

<%self:column50>
<h2>${_(u"Current Scan")}</h2>
<%self:columnsection_dashed>
<ul>
  <li>${_(u"Master is: %s") % c.masterproxy_state_set.get('master')}
      %if c.current_scan:
        (${h.link_to(c.current_scan,
            h.url_for(controller='scan', action='view', id=c.current_scan_id))})
        (${h.link_to(_(u"Stop"), h.url_for(controller='scan',action='stop_smooth'))})
        (${h.link_to(_(u"Abort Now"), h.url_for(controller='scan',action='stop'))})
      %endif
  </li>
</ul>
</%self:columnsection_dashed>

<h2>${_(u"State of Nodes")}</h2>
<%self:columnsection_dashed>
<ul>
 %if c.nodestates and len(c.nodestates):
    %for nodename,state in c.nodestates.items():
    <li>
      ${name_link_to_node(nodename)}:
       %if state:
        ${state.get('')}
       %else:
       ${_(u"unreachable")}
       %endif
    </li>
    %endfor
 %else:
   <li>${_(u"No nodes added to mapwoc-cluster.")}</li>
 %endif
</ul>
</%self:columnsection_dashed>

<%doc>
<h2>${_(u"Activity of Nodes")}</h2>
<table>
  <tr><th>${_(u"Name")}</th><th>${_(u"Address")}</th><th>${_(u"State")}</th></tr>
  %for nodekey in c.node_conf_parser.sections():
    <tr>
      <td>${h.link_to(c.node_conf_parser.get(nodekey, 'name'), h.url_for(controller='node',action='view',id=nodekey))}</td>
      <td>${c.node_conf_parser.get(nodekey, 'ip')}:${c.node_conf_parser.get(nodekey, 'port')}</td>
      <td>${c.nodestates[nodekey]}</td></tr>
  %endfor
</table>
</%doc>

</%self:column50>

<%self:column50>
 <h2>${_(u"State of Redirector")}</h2>
  <%self:columnsection>

  <h3>${_(u"State")}</h3>
  ${c.redirectorstate}

  <h3>${_(u"Last served URLs")}</h3>
  ${start_leftindent_hl_list()}
  %if len(c.redirector_last_urls) >0:
   <ul>
   %for rv in c.redirector_last_urls:
    <li>
     ${rv.hcsid}
     <img src="/img/arrow_right.png" alt="&rarr;" />
     ${h.link_to(rv.url, h.url_for(controller='result',action='by_url',id='1'))}
     <br />
     <small>
     <%
     import datetime
     visit_timestamp = datetime.datetime.fromtimestamp(float(rv.date))
     context.write(visit_timestamp.strftime(_("%H:%M:%S")))
     %></small>
    </li>
   %endfor
   </ul>
  %else:
   ${_(u"No URLs served since last loading of URL-List.")}
  %endif
  ${end_leftindent_hl_list()}

  <h3>${_(u"Next URLs")}</h3>
  ${start_leftindent_hl_list()}
  %if len(c.redirector_next_urls) > 0:
   <ul>
   %for url in c.redirector_next_urls:
    %if len(url) > 0:
    <li>${h.link_to(url, h.url_for(controller='result',action='by_url',id=url))}</li>
    %endif
   %endfor
   </ul>
  %else:
   ${_(u"Redirector has no URLs to serve next.")}
  %endif
  ${end_leftindent_hl_list()}
  
  </%self:columnsection>
 </%self:column50>
 </div>
 <br clear="all" />
</%self:box>
